# -*- coding: iso-8859-1 -*-
##############################################################################
#
# Copyright (c) 2005-2006 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import wizard
import tools

view_form_end = """<?xml version="1.0"?>
<form string="Language file loaded.">
	<separator string="Installation done" colspan="4"/>
	<label string="The selected language has been successfully installed." colspan="4"/>
</form>"""

view_form = """<?xml version="1.0"?>
<form string="System Upgrade">
	<separator string="System Upgrade" colspan="4"/>
	<label string="Your system will be upgraded, please choose a language:" colspan="4"/>
	<field name="lang" colspan="4"/>
	<label string="Note that this operation may take a few minutes." colspan="4"/>
</form>"""


def _lang_get(*args):
	print args
	return [('fr','fr'),('en','English')]

fields_form = {
	'lang': {'string':'Language', 'type':'selection', 'selection':[
		('fr_FR','French'),
		('zh_CN', 'Chinese (CN)'),
		('zh_TW', 'Chinese (TW)'),
		('cs_CZ', 'Czech'),
		('nl_NL', 'Dutch'),
		('fr_FR', 'French'),
		('de_DE', 'German'),
		('hu_HU', 'Hungarian'),
		('it_IT', 'Italian'),
		('pt_BR', 'Portugese (Brasil)'),
		('pt_PT', 'Portugese (Portugal)'),
		('ro_RO', 'Romanian'),
		('ru_RU', 'Russian'),
		('es_AR', 'Spanish (Argentina)'),
		('es_ES', 'Spanish (Spain)'),
		('sv_SE', 'Swedish')
	]},
}

class wizard_lang_install(wizard.interface):
	def _lang_install(self, cr, uid, data, context):
		print cr, uid, data, context

		lang = data['form']['lang']
		if lang and lang != 'en_EN':
			filename = tools.config["root_path"] + "/i18n/" + lang + ".csv"
			lg = lang.split('_')[0]
			tools.trans_load(cr.dbname, filename, lg)
		return {}

	states = {
		'init': {
			'actions': [], 
			'result': {'type':'form', 'arch':view_form, 'fields': fields_form, 'state':[('end','Cancel'),('start','Start installation')]}
		},
		'start': {
			'actions': [_lang_install],
			'result': {'type':'form', 'arch':view_form_end, 'fields': {}, 'state':[('end','Ok')]}
		},
	}
wizard_lang_install('module.lang.install')

