# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2004-2006 TINY SPRL. (http://tiny.be) All Rights Reserved.
#
# $Id: account.py 1005 2005-07-25 08:41:42Z nicoe $
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import fields, osv

class account_analytic_account(osv.osv):
	def _invoiced_calc(self, cr, uid, ids, name, arg, context={}):
		res = {}
		for account in self.browse(cr, uid, ids):
			invoiced = {}
			cr.execute('select distinct h.invoice_id from hr_analytic_timesheet h left join account_analytic_line l on (h.line_id=l.id) where account_id=1', (account.id,))
			invoice_ids = filter(None, map(lambda x: x[0], cr.fetchall()))
			for invoice in self.pool.get('account.invoice').browse(cr, uid, invoice_ids, context):
				res.setdefault(account.id, 0.0)
				res[account.id] += invoice.amount_untaxed
		for id in ids:
			res[id] = round(res.get(id, 0.0),2)
		return res
	_inherit = "account.analytic.account"
	_columns = {
		'pricelist_id' : fields.many2one('product.pricelist', 'Sale Pricelist'),
		'amount_max': fields.float('Max. Invoice Price'),
		'amount_invoiced': fields.function(_invoiced_calc, method=True, string='Invoiced Amount'),
		'state': fields.selection([
			('open','Open'),
			('pending','Pending'),
			('close','Close'),
			], 'State', required=True),
	}
	_defaults = {
		'state' : lambda *a : 'open',
	}
account_analytic_account()

class hr_analytic_timesheet(osv.osv):
	_inherit = 'hr.analytic.timesheet'
	_columns = {
		'invoice_id': fields.many2one('account.invoice', 'Invoice'),
		'to_invoice': fields.boolean('To Invoice')
	}
	def on_change_account_id(self, cr, uid, ids, account_id):
		if not account_id:
			return {}
		st = self.pool.get('account.analytic.account').read(cr, uid, [account_id], ['pricelist_id'])[0]['pricelist_id']
		return {'value' : {'to_invoice': bool(st)}}
	_defaults = {
		'to_invoice' : lambda *a : False,
	}
hr_analytic_timesheet()

