##############################################################################
#
# Copyright (c) 2004-2006 TINY SPRL. (http://tiny.be) All Rights Reserved.
#
# $Id: wizard_track_line.py 4304 2006-10-25 09:54:51Z ged $
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import wizard
import netsvc
import pooler

import time
from osv import osv

ask_form = '''<?xml version="1.0"?>
<form string="Tracking a move">
  <label colspan="4" string="Are you REALLY sure you want to track this line ?" />
</form>
'''

track_form = '''<?xml version="1.0"?>
<form string="Tracking a move">
 <label colspan="4" string="You can use the following code as template for information:" />
 <label colspan="2" string="%(move)d: Current move id" />
 <label colspan="2" string="%(date)s: Current date in the YYYYMMDDHHMM form" />
 <field name="tracking_prefix" colspan="4"/>
</form>
'''
fields = {
		'tracking_prefix': {'string': 'Tracking prefix', 'type': 'char', 'size': 64, 'required': True, 'default': lambda *a: '%(date)s:%(move)d'}
		}

def _track_lines(self, cr, uid, data, context):
	move_id = data['id']

	lot_obj = pooler.get_pool(cr.dbname).get('stock.lot')
	move_obj = pooler.get_pool(cr.dbname).get('stock.move')

	move = move_obj.browse(cr, uid, [move_id])[0]
	track_data = {'date': time.strftime('%Y%m%d%H%M')}
	for idx in range(move.product_qty):
		update_val = {'product_qty': 1}
		if idx:
			current_move = move_obj.copy(cr, uid, move.id, {'state': move.state, 'production_id': move.production_id.id})
		else:
			current_move = move.id
		track_data['move'] = current_move
		new_lot = lot_obj.create(cr, uid, {'name': ('%s' % data['form']['tracking_prefix']) % track_data})
		update_val['lot_id'] = new_lot
		move_obj.write(cr, uid, [current_move], update_val)
	return {}

class wizard_track_move(wizard.interface):
	states = {
		'init': {
			'actions': [],
			'result': {'type':'form', 'arch': ask_form, 'fields': {}, 'state':[('ask','Yes'), ('end', 'No')]}
		},
		'ask': {
			'actions': [],
			'result': {'type': 'form', 'arch': track_form, 'fields': fields, 'state': [('track', 'Ok'), ('end', 'Cancel')]},
			},
		'track': {
			'actions': [_track_lines],
			'result': {'type':'state', 'state':'end'}
		}
	}

wizard_track_move('stock.move.track')

